unit mycomboboxu;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, StdCtrls;

type

  { TMyCombobox }

  TMyCombobox = class ( TCombobox )
    procedure KeyPress(var Key: Char); override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('My-Tools', [TMyComboBox]);
end;

{ TMyCombobox }

procedure TMyCombobox.KeyPress(var Key: Char);
var i : integer;
    s : string;
begin
 inherited;
 if Key = #8 then
 begin
  if (SelStart > 1) then SelStart := SelStart - 1 else
  if SelLength > 1 then
  begin
   Text := '';
   Change;
   Key := #0;
   exit;
  end;
  s := copy(Text, 1, SelStart);
 end else
 s := copy(Text, 1, SelStart) + Key;
 for i := 0 to Pred(Items.Count) do
  if AnsiCompareText(s, copy(Items[i], 1, Length(s))) = 0 then
  begin
   Text := Items[i];
   SelStart := Length(s);
   SelLength := Length(Text) - Length(s);
   Change;
   Key := #0;
   Break;
  end;
end;

end.

